Summary:        A lightweight multi-platform, multi-architecture disassembly framework
Name:           capstone
Version:        5.0.1
Release:        2%{?dist}
License:        BSD
URL:            http://www.capstone-engine.org/
Source0:        https://github.com/capstone-engine/capstone/archive/%{version}.tar.gz

BuildRequires:  gcc make
BuildRequires:  git python3 python3-devel python3-setuptools
%ifarch %{java_arches}
BuildRequires:  jna java-devel
%endif

%description
Capstone is a disassembly framework with the target of becoming the ultimate
disasm engine for binary analysis and reversing in the security community.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    devel
Capstone is a disassembly framework with the target of becoming the ultimate
disasm engine for binary analysis and reversing in the security community.
The %{name}-devel package contains libraries and header files for developing
applications that use %{name}.

%package	-n python3-capstone
Summary:        Python3 bindings for %{name}
Requires:       %{name} = %{version}-%{release}
Provides:       %{name}-python3 = %{version}-%{release}
Provides:       %{name}-python3 = %{version}-%{release}
Obsoletes:      %{name}-python3 < %{version}-%{release}

%description    -n python3-capstone
Capstone is a disassembly framework with the target of becoming the ultimate
disasm engine for binary analysis and reversing in the security community.
The python3-capstone package contains python3 bindings for %{name}.

%ifarch %{java_arches}
%package        java
Summary:        Java bindings for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    java
Capstone is a disassembly framework with the target of becoming the ultimate
disasm engine for binary analysis and reversing in the security community.
The %{name}-java package contains java bindings for %{name}.
%endif


%prep
%autosetup -n %{name}-%{version}


%build
%make_build PYTHON3=%{__python3}

sed -i 's;%{buildroot};;' capstone.pc
grep -v archive capstone.pc > capstone.pc.tmp
mv capstone.pc.tmp capstone.pc

pushd bindings/python
%py3_build
popd

%ifarch %{java_arches}
pushd bindings/java
%make_build PYTHON2=%{__python3} PYTHON3=%{__python3}
popd
%endif


%install
%make_install LIBDIRARCH=%{_lib}
find %{buildroot} -name '*.la' -delete
find %{buildroot} -name '*.a' -delete

pushd bindings/python
%py3_install
popd

%ifarch %{java_arches}
install -D -p -m 0644 bindings/java/%{name}.jar  %{buildroot}/%{_javadir}/%{name}.jar
%endif


%check
ln -s libcapstone.so.4 libcapstone.so
%make_build check LD_LIBRARY_PATH="`pwd`"


%files
%license LICENSE.TXT LICENSE_LLVM.TXT
%doc CREDITS.TXT ChangeLog README.md SPONSORS.TXT
%{_libdir}/*.so.*
%{_bindir}/cstool

%files devel
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/*

%files -n python3-capstone
%{python3_sitelib}/*egg-info
%{python3_sitelib}/%{name}

%ifarch %{java_arches}
%files java
%{_javadir}/
%endif

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.0.1-2
- Rebuilt for loongarch release

* Thu Dec 21 2023 Upgrade Robot <upbot@opencloudos.org> - 5.0.1-1
- Upgrade to version 5.0.1

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.0.2-4
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.0.2-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.0.2-2
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Apr 07 2023 Miaojun Dong <zoedong@tencent.com> - 4.0.2-1
- initial build
